package ee.ut.joshi.connectsix.ai.gametree;

import ee.ut.joshi.connectsix.model.Move;

/**
 * Helper class to store moves and their score value within game tree search
 * 
 */
public class MoveScorePair implements Comparable<MoveScorePair> {

	private Move move;
	private Integer score;

	public MoveScorePair( Move move, Integer score ) {

		this.move = move;
		this.score = score;
	}

	public Move getMove() {
		return move;
	}

	public void setMove( Move move ) {
		this.move = move;
	}

	public Integer getScore() {
		return score;
	}

	public void setScore( Integer score ) {
		this.score = score;
	}

	@Override
	public int compareTo( MoveScorePair msPair ) {

		return score.compareTo( msPair.score );
	}

	@Override
	public String toString() {
		return "[move=" + move + ", score=" + score + "]";
	}
}
