package ee.ut.joshi.connectsix.ai.genetic;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import org.apache.log4j.Logger;

public class PopulationStats {

	private static Logger log = Logger.getLogger( PopulationStats.class );

	private static int iteration = 0;
	
	private static int keepmaxiters = 2;
	

	public static void logForest( Individual indiv ) {
		
		logForest( 0, indiv );
	}

	public static void logForest( int indx, Individual indiv ) {
		

		if( indx == 0 )
			iteration++;

		if( iteration > keepmaxiters ) {
			deletePrevious( indx );
		}

		File file = new File( "log/forests/forests_iter_" + String.format( "%03d", iteration ) + "_" + String.format( "%02d", indx ) + ".xml" );
		BufferedWriter out;

		try {

			out = new BufferedWriter( new FileWriter( file ) );

			String competitionStats = "";
			competitionStats += indiv.getWinsOne() + ";";
			competitionStats += indiv.getDrwsOne() + ";";
			competitionStats += indiv.getLossOne() + ";";
			competitionStats += indiv.getWinsTwo() + ";";
			competitionStats += indiv.getDrwsTwo() + ";";
			competitionStats += indiv.getLossTwo() + ";";

			String result = "Individual value=" + indiv.getValue() + ";generation=" + indiv.getGeneration();
			result += ";competitionStats=" + competitionStats;

			out.write( "<!-- " + result + " -->" );

			indiv.getForest().toStringXML( out );

			out.close();

		} catch( IOException e ) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static void deletePrevious( int indx ) {

		File file = new File( "log/forests/forests_iter_" + String.format( "%03d", iteration-keepmaxiters ) + "_" + String.format( "%02d", indx ) + ".xml" );
		file.delete();
	}

	public static void logStats( List<Individual> population ) {

		int min = Integer.MAX_VALUE;
		int avg = 0;
		int max = Integer.MIN_VALUE;

		int tmp;

		String values = "Population values=";

		for( Individual individual : population ) {
			tmp = individual.getValue();

			min = tmp < min ? tmp : min;
			avg += tmp;
			max = tmp > max ? tmp : max;

			values = values + tmp + ";";
		}

		avg = avg / population.size();

		Logger.getLogger( "forestvaluestats" ).info( values );

		log.info( "Population stats;max=" + max + ";avg=" + avg + ";=min" + min );
	}

	public static void logGenerations( List<Individual> population ) {

		String result = ";";

		for( Individual individual : population ) {
			result += individual.getGeneration() + ";";
		}

		log.info( "Generation survival rates " + result );
	}

	public static void logGamestats( List<Individual> population ) {

		boolean firstLogged = false;

		for( Individual individual : population ) {

			String netStats = "Best individuals stats=";
			netStats += individual.getWinsOne() + ";";
			netStats += individual.getDrwsOne() + ";";
			netStats += individual.getLossOne() + ";";
			netStats += individual.getWinsTwo() + ";";
			netStats += individual.getDrwsTwo() + ";";
			netStats += individual.getLossTwo() + ";";

			log.info( netStats );

			if( !firstLogged ) {

				Logger.getLogger( "forestgamestats" ).trace( netStats );

				firstLogged = true;
			}
		}
	}
}
