package ee.ut.joshi.connectsix.ai.randomforest.connect6;

import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttribute;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeDraw;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeField;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributePlayer;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.model.Board;

public class Connect6DataEntry implements DataEntry {

	private List<DataAttributeField> fields = new ArrayList<>( 19*19 );

	private DataAttributePlayer winner;

	public Connect6DataEntry() {
	}

	public Connect6DataEntry( byte[] fields, byte winner ) {

		for( byte b : fields ) {
			this.fields.add( new DataAttributeField( b ) );
		}
		
		if( winner == Board.EMPTY ) {
		
			this.winner = new DataAttributeDraw();
			
		} else {

			this.winner = new DataAttributePlayer( winner );
		}
	}

	public DataAttributeField getFieldValue( Integer fieldIndx ) {

		return fields.get( fieldIndx );
	}

	public void addFieldValue( Integer fieldIndx, DataAttributeField value ) {

		fields.add( fieldIndx, value );
	}
	
	public void setFields( List<DataAttributeField> fields ) {
		this.fields = fields;
	}
	
	public void setFields( byte[] fields ) {

		for( byte b : fields ) {
			this.fields.add( new DataAttributeField( b ) );
		}
	}

	public void setWinner( DataAttributePlayer winner ) {

		this.winner = winner;
	}

	@Override
	public DataAttributePlayer getCategory() {

		return winner;
	}

	@Override
	public DataAttribute getAttrValue( String attr ) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public DataAttribute getAttrValue( Integer attrIndx ) {

		return fields.get( attrIndx );
	}

	@Override
	public String toString() {
		return "Connect6DataEntry [fields=" + fields + ", winner=" + winner + "]";
	}
}
