package ee.ut.joshi.connectsix.ai.randomforest.connect6;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataEntryDao;
import ee.ut.joshi.connectsix.model.Board;

public class Connect6DataEntryDao implements DataEntryDao {

	private Connection con;

	public Connect6DataEntryDao( Connection con ) {

		this.con = con;
	}

	@Override
	public void saveDataEntry( DataEntry dataEntry ) {

		try {

			Connect6DataEntry entry = (Connect6DataEntry) dataEntry;

			String sqlQuery = "insert into connectsix values(";

			for( int i = 0; i < Board.NROFFIELDS; i++ ) {
				sqlQuery += "?,";
			}
			
			sqlQuery += "?,";
			sqlQuery += "null)";

			PreparedStatement stmt = con.prepareStatement( sqlQuery );
			stmt.clearParameters();

			for( int i = 0; i < Board.NROFFIELDS; i++ ) {

				stmt.setByte( i + 1, entry.getFieldValue( i ).getValue() );
			}

			stmt.setByte( Board.NROFFIELDS + 1, entry.getCategory().getValue() );

			stmt.execute();

			stmt.close();

		} catch( SQLException e ) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
