package ee.ut.joshi.connectsix.ai.randomforest.connect6;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;
import ee.ut.joshi.connectsix.model.Board;

public class InitDatabaseConnect6 implements InitDatabase {

	private Connection con;

	private static final Logger log = Logger.getLogger( InitDatabase.class );

	public InitDatabaseConnect6() {

		initDb();
	}

	@Override
	public void initDb() {

		log.info( "Starting DB" );

		try {

			Class.forName( "org.hsqldb.jdbc.JDBCDriver" );
		} catch( ClassNotFoundException e ) {
			e.printStackTrace();
		}

		try {

			con = DriverManager.getConnection( "jdbc:hsqldb:data/connectsix", "SA", "" );

			con.createStatement().execute( "drop table connectsix if exists" );

			String sql = "create table connectsix (";

			for( int i = 1; i <= Board.NROFFIELDS; i++ ) {

				sql += "f" + i + " tinyint,";
			}

			sql += "winner tinyint,";
			sql += "id identity not null";
			sql += ")";

			con.createStatement().executeUpdate( sql );

		} catch( SQLException e ) {
			e.printStackTrace();
		}
	}

	@Override
	public Connection getConnection() {
		return con;
	}
}
