package ee.ut.joshi.connectsix.ai.randomforest.dataattr;

import java.util.HashMap;
import java.util.List;

import org.apache.log4j.Logger;

public class BasicDataEntry implements DataEntry {

	private static final Logger log = Logger.getLogger( BasicDataEntry.class );

	private final HashMap<Integer, DataAttribute> attrMap = new HashMap<>();

	public BasicDataEntry( List<Integer> attrIndxs, Byte[] values ) {

		if( attrIndxs.size() != values.length ) {

			log.fatal( "Number of attributes do not match number of values!" );
			System.exit( 1 );
		}
		
		for( int i = 0; i < values.length; i++ ) {
		
			attrMap.put( attrIndxs.get( i ), new DataAttributeByte( values[ i ] ) );
		}
	}

	@Override
	public DataAttribute getAttrValue( Integer attrIndx ) {

		return attrMap.get( attrIndx );
	}

	@Override
	public DataAttribute getAttrValue( String attr ) {

		return attrMap.get( Integer.valueOf( attr ) );
	}

	@Override
	public DataAttribute getCategory() {

		return null;
	}

	@Override
	public String toString() {
		return "BasicDataEntry [attrMap=" + attrMap + "]";
	}
}
