package ee.ut.joshi.connectsix.ai.randomforest.dataattr;

/**
 * Data attribute for byte type.
 */
public class DataAttributeByte extends DataAttribute {

	private Byte value;

	public DataAttributeByte( Byte value ) {

		this.value = value;
	}

	@Override
	public int compareTo( DataAttribute o ) {

		DataAttributeByte byt = (DataAttributeByte) o;

		return value.compareTo( byt.getValue() );
	}

	@Override
	public boolean equals( Object obj ) {

		if( obj instanceof DataAttributeByte ) {

			DataAttributeByte byt = (DataAttributeByte) obj;

			return value.equals( byt.getValue() );
		}

		return false;
	}

	@Override
	public int hashCode() {

		return value.hashCode();
	}

	public Byte getValue() {
		return value;
	}

	public void setValue( Byte value ) {
		this.value = value;
	}

	@Override
	public String toString() {

		return value.toString();
	}
}
