package ee.ut.joshi.connectsix.ai.randomforest.dataattr;

/**
 * Data attribute value in form of String object.
 */
public class DataAttributeString extends DataAttribute {

	private String value;

	public DataAttributeString( String value ) {

		this.value = value;
	}

	@Override
	public int compareTo( DataAttribute o ) {

		DataAttributeString str = (DataAttributeString) o;

		return value.compareTo( str.getValue() );
	}

	@Override
	public boolean equals( Object obj ) {

		if( obj instanceof DataAttributeString ) {

			DataAttributeString str = (DataAttributeString) obj;

			return value.equals( str.getValue() );
		}

		return false;
	}

	@Override
	public int hashCode() {

		return value.hashCode();
	}

	public String getValue() {
		return value;
	}

	public void setValue( String value ) {
		this.value = value;
	}

	@Override
	public String toString() {

		return value;
	}
}
