package ee.ut.joshi.connectsix.ai.randomforest.dataattr;

/**
 * A single data entry in the set of data.
 */
public interface DataEntry {

	/**
	 * @return Returns the entry category value as #DataAttribute
	 */
	public DataAttribute getCategory();

	/**
	 * Returns entry attribute value from specific field as #DataAttribute.
	 * 
	 * @param attr Field name from where to look for the attribute value
	 * @return Entry attribute value from specified field
	 */
	public DataAttribute getAttrValue( String attr );

	/**
	 * Returns entry attribute value from specific field as #DataAttribute.
	 * 
	 * @param attrIndx Field index from where to look for the attribute value
	 * @return Entry attribute value from specified field
	 */
	public DataAttribute getAttrValue( Integer attrIndx );
}
