package ee.ut.joshi.connectsix.ai.randomforest.db;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataSet;

/**
 * Data access object for #DataSet
 */
public interface DataSetDao {

	/**
	 * @return Full data set from database
	 */
	public DataSet getDataSet();

	/**
	 * @param limit Number of results in returned data set
	 * @return Returns specified number of newest dataEntries
	 */
	public DataSet getDataSet( Integer limit );

	/**
	 * Retrieves filtered data set from database. Filtering is based on a field
	 * column name and its value
	 * 
	 * @param column Field column name in database
	 * @param value Field value to be filtered on
	 * @return Filtered data set from database
	 */
	public DataSet getDataSet( String column, String value );

}
