package ee.ut.joshi.connectsix.ai.randomforest.db;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.connect6.Connect6DataSet;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataSet;
import ee.ut.joshi.connectsix.ai.randomforest.football.FootballDataSet;
import ee.ut.joshi.connectsix.ai.randomforest.linear.LinearDataSet;
import ee.ut.joshi.connectsix.ai.randomforest.tictactoe.TicDataSet;

public class DataSetFactory {

	private static final Logger log = Logger.getLogger( DataSetFactory.class );

	/**
	 * Generates new data set of same type as input.
	 * 
	 * @param dataSet Source data set for 'cloning'
	 * @return Generated new empty data set of same type as input
	 */
	public static DataSet emptyDataSet( DataSet dataSet ) {

		DataSet newSet;

		if( dataSet instanceof FootballDataSet ) {

			newSet = new FootballDataSet();

		} else if( dataSet instanceof TicDataSet ) {

			newSet = new TicDataSet();

		} else if( dataSet instanceof Connect6DataSet ) {

			newSet = new Connect6DataSet();

		} else if( dataSet instanceof LinearDataSet ) {

			newSet = new LinearDataSet();

		}   else {

			log.fatal( "DataSet not supported!" );

			System.exit( 1 );
			return null;
		}

		return newSet;
	}
}
