package ee.ut.joshi.connectsix.ai.randomforest.football;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttribute;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeString;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;

public class FootballDataEntry implements DataEntry {

	private static final Logger log = Logger.getLogger( FootballDataEntry.class );

	private DataAttributeString day;
	private DataAttributeString outlook;
	private DataAttributeString temperature;
	private DataAttributeString humidity;
	private DataAttributeString wind;
	private DataAttributeString playball;

	public FootballDataEntry() {

	}

	public FootballDataEntry( String day, String outlook, String temperature, String humidity, String wind, String playball ) {

		this.day = new DataAttributeString( day );
		this.outlook = new DataAttributeString( outlook );
		this.temperature = new DataAttributeString( temperature );
		this.humidity = new DataAttributeString( humidity );
		this.wind = new DataAttributeString( wind );
		this.playball = new DataAttributeString( playball );
	}

	public FootballDataEntry( DataAttributeString day, DataAttributeString outlook, DataAttributeString temperature,
			DataAttributeString humidity, DataAttributeString wind, DataAttributeString playball ) {

		this.day = day;
		this.outlook = outlook;
		this.temperature = temperature;
		this.humidity = humidity;
		this.wind = wind;
		this.playball = playball;
	}

	@Override
	public DataAttribute getCategory() {

		return playball;
	}

	@Override
	public DataAttribute getAttrValue( String attr ) {

		log.trace( "Retreiving value for attr=" + attr );

		if( attr.equals( "day" ) )
			return day;
		else if( attr.equals( "outlook" ) )
			return outlook;
		else if( attr.equals( "temperature" ) )
			return temperature;
		else if( attr.equals( "humidity" ) )
			return humidity;
		else if( attr.equals( "wind" ) )
			return wind;
		else if( attr.equals( "playball" ) )
			return playball;

		return null;
	}

	@Override
	public DataAttribute getAttrValue( Integer attrIndx ) {

		log.trace( "Retreiving value for attrIndx=" + attrIndx );

		// Happens with TreeNodeFailure
		if( attrIndx == null )
			return null;

		if( attrIndx == 0 )
			return day;
		else if( attrIndx == 1 )
			return outlook;
		else if( attrIndx == 2 )
			return temperature;
		else if( attrIndx == 3 )
			return humidity;
		else if( attrIndx == 4 )
			return wind;
		else if( attrIndx == 5 )
			return playball;

		return null;
	}

	public DataAttributeString getDay() {
		return day;
	}

	public void setDay( DataAttributeString day ) {
		this.day = day;
	}

	public DataAttributeString getOutlook() {
		return outlook;
	}

	public void setOutlook( DataAttributeString outlook ) {
		this.outlook = outlook;
	}

	public DataAttributeString getTemperature() {
		return temperature;
	}

	public void setTemperature( DataAttributeString temperature ) {
		this.temperature = temperature;
	}

	public DataAttributeString getHumidity() {
		return humidity;
	}

	public void setHumidity( DataAttributeString humidity ) {
		this.humidity = humidity;
	}

	public DataAttributeString getWind() {
		return wind;
	}

	public void setWind( DataAttributeString wind ) {
		this.wind = wind;
	}

	public DataAttributeString getPlayball() {
		return playball;
	}

	public void setPlayball( DataAttributeString playball ) {
		this.playball = playball;
	}

	@Override
	public String toString() {
		return "FootballDataEntry [day=" + day + ", outlook=" + outlook + ", temperature=" + temperature + ", humidity=" + humidity
				+ ", wind=" + wind + ", playball=" + playball + "]";
	}
}
