package ee.ut.joshi.connectsix.ai.randomforest.football;

import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataSet;

public class FootballDataSet implements DataSet {

	private List<String> header;
	private List<DataEntry> data;
	
	private List<Integer> attrIndexes;

	public FootballDataSet() {
		
		data = new ArrayList<>();

		header = new ArrayList<>();
		header.add( "day" );
		header.add( "outlook" );
		header.add( "temperature" );
		header.add( "humidity" );
		header.add( "wind" );
		header.add( "playball" );
		
		attrIndexes = new ArrayList<>();
		attrIndexes.add( 1 );
		attrIndexes.add( 2 );
		attrIndexes.add( 3 );
		attrIndexes.add( 4 );
	}

	@Override
	public void addDataEntry( DataEntry dataEntry ) {

		data.add( dataEntry );
	}
	
	@Override
	public List<Integer> getAttrIndexes() {
	
		return attrIndexes;
	}

	@Override
	public List<String> getHeader() {

		return header;
	}

	@Override
	public void setHeader( List<String> header ) {

		this.header = header;
	}

	@Override
	public List<DataEntry> getData() {

		return data;
	}

	@Override
	public void setData( List<DataEntry> data ) {

		this.data = data;
	}

	@Override
	public String toString() {
		
		String result = new String();
		
		for( String header : getHeader() ) {
			result += header + ";";
		}
		
		result += "\n";
		
		for( DataEntry dataEntry : getData() ) {
			result += dataEntry + "\n";
		}

		return result;
	}
}
