package ee.ut.joshi.connectsix.ai.randomforest.football;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeString;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataSetDao;
import ee.ut.joshi.connectsix.ai.randomforest.tictactoe.TicDataSet;

public class FootballDataSetDao implements DataSetDao {

	private Connection con;

	public FootballDataSetDao( Connection con ) {

		this.con = con;
	}

	@Override
	public FootballDataSet getDataSet() {

		FootballDataSet dataset = new FootballDataSet();

		List<DataEntry> result = new ArrayList<>();

		try {

			PreparedStatement stmt = con.prepareStatement( "select * from football" );
			stmt.clearParameters();

			ResultSet rs = stmt.executeQuery();

			while( rs.next() ) {

				FootballDataEntry fbEntry = new FootballDataEntry();

				fbEntry.setDay( new DataAttributeString( rs.getString( "day" ) ) );
				fbEntry.setOutlook( new DataAttributeString( rs.getString( "outlook" ) ) );
				fbEntry.setTemperature( new DataAttributeString( rs.getString( "temperature" ) ) );
				fbEntry.setHumidity( new DataAttributeString( rs.getString( "humidity" ) ) );
				fbEntry.setWind( new DataAttributeString( rs.getString( "wind" ) ) );
				fbEntry.setPlayball( new DataAttributeString( rs.getString( "playball" ) ) );

				result.add( fbEntry );
			}

		} catch( SQLException e ) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		dataset.setData( result );

		return dataset;
	}
	
	@Override
	public TicDataSet getDataSet( Integer limit ) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public FootballDataSet getDataSet( String column, String value ) {

		FootballDataSet dataset = new FootballDataSet();

		List<DataEntry> result = new ArrayList<>();

		try {

			PreparedStatement stmt = con.prepareStatement( "select * from football where " + column + "=?" );
			stmt.clearParameters();

			// stmt.setString( 1, column );
			stmt.setString( 1, value );

			ResultSet rs = stmt.executeQuery();

			while( rs.next() ) {

				FootballDataEntry fbEntry = new FootballDataEntry();

				fbEntry.setDay( new DataAttributeString( rs.getString( "day" ) ) );
				fbEntry.setOutlook( new DataAttributeString( rs.getString( "outlook" ) ) );
				fbEntry.setTemperature( new DataAttributeString( rs.getString( "temperature" ) ) );
				fbEntry.setHumidity( new DataAttributeString( rs.getString( "humidity" ) ) );
				fbEntry.setWind( new DataAttributeString( rs.getString( "wind" ) ) );
				fbEntry.setPlayball( new DataAttributeString( rs.getString( "playball" ) ) );

				result.add( fbEntry );
			}

		} catch( SQLException e ) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		dataset.setData( result );

		return dataset;
	}
}
