package ee.ut.joshi.connectsix.ai.randomforest.football;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;

public class InitDatabaseFootball implements InitDatabase {

	private Connection con;

	private static final Logger log = Logger.getLogger( InitDatabase.class );

	public InitDatabaseFootball() {

		initDb();
	}

	@Override
	public void initDb() {

		log.info( "Starting DB" );

		try {

			Class.forName( "org.hsqldb.jdbc.JDBCDriver" );
		} catch( ClassNotFoundException e ) {
			e.printStackTrace();
		}

		try {

			con = DriverManager.getConnection( "jdbc:hsqldb:data/connectsix", "SA", "" );

			con.createStatement().execute( "drop table football if exists" );

			//@formatter:off
			con.createStatement().executeUpdate(
					"create table football (" +
					"day varchar(10)," +
					"outlook varchar(10)," +
					"temperature varchar(10)," +
					"humidity varchar(10)," +
					"wind varchar(10)," +
					"playball varchar(10)," +
					")" );
			//@formatter:on
		} catch( SQLException e ) {
			e.printStackTrace();
		}
	}

	@Override
	public Connection getConnection() {
		return con;
	}
}
