package ee.ut.joshi.connectsix.ai.randomforest.linear;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;
import ee.ut.joshi.connectsix.main.ConnectObotProps;

public class InitDatabaseLinear implements InitDatabase {

	private static final Logger log = Logger.getLogger( InitDatabase.class );
	
	private Connection con;
	
	private static final boolean usePrevState = ConnectObotProps.usePreviousState();

	public InitDatabaseLinear() {

		initDb();
	}

	@Override
	public void initDb() {

		log.info( "Starting DB" );

		try {

			Class.forName( "org.hsqldb.jdbc.JDBCDriver" );
		} catch( ClassNotFoundException e ) {
			e.printStackTrace();
		}

		try {

			con = DriverManager.getConnection( "jdbc:hsqldb:data/linear", "SA", "" );

		} catch( SQLException e ) {
			e.printStackTrace();
		}

		// Drop and recreate table if starting from scratch
		if( !usePrevState ) {

			try {

				con.createStatement().execute( "drop table linear_smart if exists" );

				String sql = "create table linear_smart (";

				for( int i = 1; i <= totalSmartFields; i++ ) {

					sql += "f" + i + " tinyint,";
				}

				sql += "winner tinyint,";
				sql += "id identity not null";
				sql += ")";

				con.createStatement().executeUpdate( sql );

			} catch( SQLException e ) {
				log.fatal( "Exiting: " + e.getMessage() );
				e.printStackTrace();
			}
		}
	}

	@Override
	public Connection getConnection() {
		return con;
	}
}
