package ee.ut.joshi.connectsix.ai.randomforest.linear;

import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttribute;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeDraw;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributeField;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributePlayer;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.model.Board;

public class LinearDataEntry implements DataEntry {

	private List<DataAttributeField> fields = new ArrayList<>( Board.NROFFIELDS );

	private DataAttributePlayer winner;

	public LinearDataEntry() {}

	public LinearDataEntry( byte[] fields, byte winner ) {

		for( byte b : fields ) {
			this.fields.add( new DataAttributeField( b ) );
		}

		if( winner == Board.EMPTY ) {

			this.winner = new DataAttributeDraw();

		} else {

			this.winner = new DataAttributePlayer( winner );
		}
	}

	public DataAttributeField getFieldValue( Integer fieldIndx ) {

		return fields.get( fieldIndx );
	}

	public void addFieldValue( DataAttributeField value ) {

		fields.add( value );
	}

	public void addFieldValue( Integer fieldIndx, DataAttributeField value ) {

		fields.add( fieldIndx, value );
	}

	public void setFields( List<DataAttributeField> fields ) {
		this.fields = fields;
	}

	public void setFields( byte[] fields ) {

		for( byte b : fields ) {
			this.fields.add( new DataAttributeField( b ) );
		}
	}

	public void setWinner( DataAttributePlayer winner ) {

		this.winner = winner;
	}

	@Override
	public DataAttributePlayer getCategory() {

		return winner;
	}

	@Override
	public DataAttribute getAttrValue( String attr ) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public DataAttribute getAttrValue( Integer attrIndx ) {

		// TODO: Null pointer? If there is no data to train on in DB most likely.
		return fields.get( attrIndx );
	}

	@Override
	public String toString() {
		return "LinearDataEntry [fields=" + fields + ", winner=" + winner + "]";
	}
}
