package ee.ut.joshi.connectsix.ai.randomforest.linear;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataEntryDao;
import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;

public class LinearDataEntryDao implements DataEntryDao {

	private Connection con;

	public LinearDataEntryDao( Connection con ) {

		this.con = con;
	}

	@Override
	public void saveDataEntry( DataEntry dataEntry ) {

		try {

			LinearDataEntry entry = (LinearDataEntry) dataEntry;

			String sqlQuery = "insert into linear_smart values(";

			for( int i = 0; i < InitDatabase.totalSmartFields; i++ ) {
				sqlQuery += "?,";
			}

			sqlQuery += "?,";
			sqlQuery += "null)";

			PreparedStatement stmt = con.prepareStatement( sqlQuery );
			stmt.clearParameters();

			for( int i = 0; i < InitDatabase.totalSmartFields; i++ ) {

				stmt.setByte( i + 1, entry.getFieldValue( i ).getValue() );
			}

			stmt.setByte( InitDatabase.totalSmartFields + 1, entry.getCategory().getValue() );

			stmt.execute();

			stmt.close();

		} catch( SQLException e ) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
