package ee.ut.joshi.connectsix.ai.randomforest.tictactoe;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;

public class InitDatabaseTic implements InitDatabase {
	
	private Connection con;

	private static final Logger log = Logger.getLogger( InitDatabase.class );

	public InitDatabaseTic() {

		initDb();
	}

	@Override
	public void initDb() {

		log.info( "Starting DB" );

		try {

			Class.forName( "org.hsqldb.jdbc.JDBCDriver" );
		} catch( ClassNotFoundException e ) {
			e.printStackTrace();
		}

		try {

			con = DriverManager.getConnection( "jdbc:hsqldb:data/tictactoe", "SA", "" );
			
			con.createStatement().execute( "drop table tictactoe if exists" );
			
			con.createStatement().executeUpdate(
					"create table tictactoe (" +
					"f1 tinyint," +
					"f2 tinyint," +
					"f3 tinyint," +
					"f4 tinyint," +
					"f5 tinyint," +
					"f6 tinyint," +
					"f7 tinyint," +
					"f8 tinyint," +
					"f9 tinyint," +
					"winner tinyint," +
					"id identity not null" +
					")" );
		} catch( SQLException e ) {
			e.printStackTrace();
		}
	}

	@Override
	public Connection getConnection() {
		return con;
	}
}
