package ee.ut.joshi.connectsix.ai.randomforest.tictactoe;

import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataSet;

public class TicDataSet implements DataSet {

	private List<String> header;
	private List<DataEntry> data;
	
	private List<Integer> attrIndexes;
	
	public TicDataSet() {
	
		data = new ArrayList<>();

		header = new ArrayList<>();
		attrIndexes = new ArrayList<>();
		
		for( int i = 0; i < 9; i++ ) {
			
			header.add( "f" + i );
			attrIndexes.add( i );
		}

		header.add( "winner" );
	}

	@Override
	public List<String> getHeader() {

		return header;
	}

	@Override
	public void setHeader( List<String> header ) {
		
		this.header = header;
	}

	@Override
	public void addDataEntry( DataEntry dataEntry ) {

		data.add( dataEntry );
	}

	@Override
	public List<Integer> getAttrIndexes() {

		return attrIndexes;
	}

	@Override
	public List<DataEntry> getData() {

		return data;
	}

	@Override
	public void setData( List<DataEntry> data ) {
		
		this.data = data;
	}
	
	@Override
	public String toString() {
		String result = new String();
		
		for( String header : getHeader() ) {
			result += header + ";";
		}
		
		result += "\n";
		
		for( DataEntry dataEntry : getData() ) {
			result += dataEntry + "\n";
		}
		
		return result;
	}
}
