package ee.ut.joshi.connectsix.ai.randomforest.tree;

import java.io.BufferedWriter;
import java.io.IOException;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttribute;

/**
 * Terminal node in the decision tree that determines category value of the data
 * entry.
 */
public class TreeLeaf extends TreeNode {

	/** Categorical value of the data entry */
	private DataAttribute categoryValue;

	public TreeLeaf( TreeNode parent, DataAttribute categoryValue ) {

		super( parent );

		this.categoryValue = categoryValue;
	}

	public DataAttribute getCategoryValue() {
		return categoryValue;
	}

	public void setCategoryValue( DataAttribute categoryValue ) {
		this.categoryValue = categoryValue;
	}

	@Override
	public String toString() {

		String result = new String();

		for( int i = 0; i < getDepth(); i++ ) {
			result += "-";
		}

		result += "TreeLeaf: branchValue=" + getBranchValue() + ", categoryValue=" + categoryValue;

		return result;
	}
	
	@Override
	public String toStringXML() {

		String result = new String("\n\t\t");

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t";
		}

		result += "<TreeLeaf branchValue=\"" + getBranchValue() 
				+ "\" categoryValue=\"" + categoryValue + "\" />";

		return result;
	}
	
	@Override
	public void toStringXML( BufferedWriter out ) throws IOException {

		String result = new String("\n\t\t");

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t";
		}

		result += "<TreeLeaf branchValue=\"" + getBranchValue() + "\" categoryValue=\"" + categoryValue + "\" />";

		out.write( result );
	}
}
