package ee.ut.joshi.connectsix.ai.randomforest.tree;

import java.io.BufferedWriter;
import java.io.IOException;

/**
 * Starting point of the decision tree.
 */
public class TreeRoot extends TreeNode {

	public TreeRoot() {

		setDepth( 1 );
		setParent( null );
	}

	@Override
	public String toString() {

		String result = new String();

		for( int i = 0; i < getDepth(); i++ ) {
			result += "-";
		}

		result += "TreeRoot: headerIndx=" + getHeaderIndx();

		for( TreeNode child : getNodes() ) {
			result += "\n" + child;
		}

		return result + "\n";
	}

	@Override
	public String toStringXML() {

		String result = new String();

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t";
		}

		result += "<TreeRoot headerIndx=\"" + getHeaderIndx() + "\">";

		for( TreeNode child : getNodes() ) {
			result += child.toStringXML();
		}

		result += "\n\t\t";

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t</TreeRoot>";
		}

		return result + "\n";
	}

	@Override
	public void toStringXML( BufferedWriter out ) throws IOException {

		String result = new String();

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t";
		}

		result += "<TreeRoot headerIndx=\"" + getHeaderIndx() + "\">";

		out.write( result );

		for( TreeNode child : getNodes() ) {
			child.toStringXML( out );
		}

		result = "\n\t\t";

		for( int i = 0; i < getDepth(); i++ ) {
			result += "\t</TreeRoot>";
		}

		out.write( result + "\n" );
	}
}
