package ee.ut.joshi.connectsix.logic;

import java.util.ArrayList;
import java.util.List;

import ee.ut.joshi.connectsix.ai.genetic.Individual;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataAttributePlayer;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataEntryDao;
import ee.ut.joshi.connectsix.ai.randomforest.linear.LinearDataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.linear.SmartDataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.train.TrainForest;
import ee.ut.joshi.connectsix.model.ConnectFourBoard;

public class ConnectFourTrainer extends Trainer {

	public ConnectFourTrainer( TrainForest trainForest, DataEntryDao entryDao ) {

		super( trainForest, entryDao );
	}

	@Override
	protected List<GeneticGameController> initGames( List<Individual> pop ) {

		List<GeneticGameController> gameList = new ArrayList<>();

		boolean logallmoves = true;

		for( Individual indivOne : pop ) {
			for( Individual indivTwo : pop ) {

				if( indivOne == indivTwo )
					continue;

				GeneticGameController game;

				if( logallmoves )
					game = new GeneticGameController( new ConnectFourBoard(), indivOne, indivTwo, true );
				else
					game = new GeneticGameController( new ConnectFourBoard(), indivOne, indivTwo );

				game.logFinalStates();
				gameList.add( game );

				logallmoves = false;
			}
		}

		return gameList;
	}

	@Override
	protected void saveGameState( DataEntryDao entryDao, GeneticGameController game, DataAttributePlayer winnerAttr ) {

		ConnectFourBoard board = (ConnectFourBoard) game.getBoard();

		// GomokuDataEntry dataEntry = new GomokuDataEntry();
		LinearDataEntry dataEntry = new SmartDataEntry( board.getFields(), board.getWinningPosition() );

		dataEntry.setWinner( winnerAttr );

		entryDao.saveDataEntry( dataEntry );
	}
}
