package ee.ut.joshi.connectsix.logic;

import ee.ut.joshi.connectsix.ai.genetic.Individual;
import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.player.NegaMaxPlayer;

public class GeneticGameController extends GameController {

	/** Keeps track of individuals used from genetic algorithm */
	private final Individual indivOne;
	private final Individual indivTwo;

	public GeneticGameController( Board<? extends Object> board, Individual indivOne, Individual indivTwo ) {

		this( board, indivOne, indivTwo, false );
	}

	public GeneticGameController( Board<? extends Object> board, Individual indivOne, Individual indivTwo, boolean verbose ) {

		this.indivOne = indivOne;
		this.indivTwo = indivTwo;

		NegaMaxPlayer plOne = new NegaMaxPlayer( Board.PLRONE, indivOne.getForest(), verbose );
		NegaMaxPlayer plTwo = new NegaMaxPlayer( Board.PLRTWO, indivTwo.getForest(), verbose );

		setBoard( board );
		setPlayerOne( plOne );
		setPlayerTwo( plTwo );

		setActivePlayer( plOne );

		if( verbose ) {

			logAllMoves();
		}
	}

	/**
	 * @return the indivOne
	 */
	public Individual getIndivOne() {
		return indivOne;
	}

	/**
	 * @return the indivTwo
	 */
	public Individual getIndivTwo() {
		return indivTwo;
	}
}
