package ee.ut.joshi.connectsix.logic.board;

import java.util.Comparator;

import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.linear.LinearBoard;

public class BoardComparator implements Comparator<Board<? extends Object>> {

	private static final BoardComparator instance = new BoardComparator();

	private BoardComparator() {}

	public static BoardComparator instance() {

		return instance;
	}

	@Override
	public int compare( Board<? extends Object> o1, Board<? extends Object> o2 ) {

		if( o1 instanceof LinearBoard && o2 instanceof LinearBoard ) {

			LinearBoard brdOne = (LinearBoard) o1;
			LinearBoard brdTwo = (LinearBoard) o2;

			return Integer.compare( brdOne.getBoardScore(), brdTwo.getBoardScore() );
		}

		return 0;
	}
}