package ee.ut.joshi.connectsix.logic.board;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.logic.factory.BoardCloneFactory;
import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.linear.LinearBoard;

public class ParallelBoardPrinter {

	private static final Logger log = Logger.getLogger( ParallelBoardPrinter.class );

	public static String toStringBoards( Board<? extends Object> boardOne, Board<? extends Object> boardTwo ) {

		if( boardOne instanceof LinearBoard && boardTwo instanceof LinearBoard ) {

			return toStringBoards( (LinearBoard) boardOne, (LinearBoard) boardTwo );

		} else {

			log.error( "Board type not supported for printing!" );

			return boardOne + "\n" + boardTwo;
		}
	}

	public static String toStringWithMoves( Board<? extends Object> boardOne ) {

		if( boardOne instanceof LinearBoard ) {

			return toStringWithMoves( (LinearBoard) boardOne );

		} else {

			log.error( "Board type not supported for printing!" );

			return boardOne.toString();
		}
	}

	public static String toStringWithMoves( LinearBoard boardOne ) {

		LinearBoard boardTwo = (LinearBoard) BoardCloneFactory.cloneBoard( boardOne );

		String[] oneSplit = boardOne.toString().split( "\n" );
		String[] twoSplit = boardTwo.toStringWithMoves().split( "\n" );

		String result = "\n";

		for( int i = 1; i < oneSplit.length; i++ ) {

			result += oneSplit[ i ] + " || " + twoSplit[ i ] + "\n";
		}

		return result;
	}

	public static String toStringBoards( LinearBoard boardOne, LinearBoard boardTwo ) {

		String[] oneSplit = boardOne.toString().split( "\n" );
		String[] twoSplit = boardTwo.toString().split( "\n" );

		String result = "\n";

		for( int i = 1; i < oneSplit.length; i++ ) {

			result += oneSplit[ i ] + " || " + twoSplit[ i ] + "\n";
		}

		return result;
	}
}
