package ee.ut.joshi.connectsix.logic.board;

import java.util.HashMap;
import java.util.Map;

public class ScorePatternFactory {

	private static final int penta = 720;
	private static final int quad = 24;
	private static final int trio = 8;
	// TODO: private static final int dual = 2;

	private static final int quadDbl = quad * 2;
	private static final int trioDbl = trio * 2;

	// TODO: private static final int dualDbl = dual * 2;

	public static Map<String, Integer> generateScorePatterns() {

		// Store each pattern and relevant score in the map
		HashMap<String, Integer> scorePatterns = new HashMap<>();

		scorePatterns.putAll( quadPatterns() );
		scorePatterns.putAll( pentaPatterns() );
		scorePatterns.putAll( trioPatterns() );

		return scorePatterns;
	}

	public static Map<String, Integer> pentaPatterns() {
		// Store each pattern and relevant score in the map
		HashMap<String, Integer> scorePatterns = new HashMap<>();

		//@formatter:off
		scorePatterns.put( "X X X X X", penta );

		scorePatterns.put( 
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X", penta );

		scorePatterns.put( 
				"X . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . X", penta );

		scorePatterns.put( 
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"X . . . .", penta );
		

		scorePatterns.put( 
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"X . . . .", penta );

		//@formatter:on

		return scorePatterns;
	}

	private static Map<String, Integer> quadPatterns() {
		// Store each pattern and relevant score in the map
		HashMap<String, Integer> scorePatterns = new HashMap<>();

		//@formatter:off
		scorePatterns.put( "0 X X X X", quad );
		scorePatterns.put( "X X X X 0", quad );
		scorePatterns.put( "0 X 0 X X 0", quadDbl );
		scorePatterns.put( "0 X X 0 X 0", quadDbl );
		scorePatterns.put( "0 X X X X 0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0", quad );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X", quad );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"X . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . 0", quad );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . X", quad );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				". X . . . . . . . ." +
				". . 0 . . . . . . ." +
				". . . X . . . . . ." +
				". . . . X . . . . ." +
				". . . . . 0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . 0 . . . . . ." +
				". . . . X . . . . ." +
				". . . . . 0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"0 . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . X . . . . ." +
				". . . . . 0", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9  
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"0 . . . .", quad );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				". . . . 0 . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"X . . . .", quad );
		
		scorePatterns.put( 
	           //0 1 2 3 4 5 6 7 8 9 
				". . . . . 0 . . . ." +
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . 0 . . . . . . ." +
				". X . . . . . . . ." +
				"0 . . . . .", quadDbl );
		
		scorePatterns.put( 
	           //0 1 2 3 4 5 6 7 8 9 
				". . . . . 0 . . . ." +
				". . . . X . . . . ." +
				". . . 0 . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"0 . . . . .", quadDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				". . . . . 0 . . . ." +
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"0 . . . . .", quadDbl );

		//@formatter:on

		return scorePatterns;
	}

	private static Map<String, Integer> trioPatterns() {
		// Store each pattern and relevant score in the map
		HashMap<String, Integer> scorePatterns = new HashMap<>();

		//@formatter:off
		scorePatterns.put( "0 0 X X X", trio );
		scorePatterns.put( "X X X 0 0", trio );
		scorePatterns.put( "0 X X X 0", trioDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9 
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0 . . . . . . . . ." +
				"0", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				"0 . . . . . . . . ." +
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				"0 . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"X . . . . . . . . ." +
				"0", trioDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				"X . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . 0 . . . . . ." +
				". . . . 0", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				"0 . . . . . . . . ." +
				". 0 . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . X", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				"0 . . . . . . . . ." +
				". X . . . . . . . ." +
				". . X . . . . . . ." +
				". . . X . . . . . ." +
				". . . . 0", trioDbl );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9		
				". . . . X . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". 0 . . . . . . . ." +
				"0 . . . .", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				". . . . 0 . . . . ." +
				". . . 0 . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"X . . . .", trio );

		scorePatterns.put( 
               //0 1 2 3 4 5 6 7 8 9
				". . . . 0 . . . . ." +
				". . . X . . . . . ." +
				". . X . . . . . . ." +
				". X . . . . . . . ." +
				"0 . . . .", trioDbl );

		//@formatter:on

		return scorePatterns;
	}
}
