package ee.ut.joshi.connectsix.logic.factory;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataEntryDao;
import ee.ut.joshi.connectsix.ai.randomforest.linear.LinearDataEntry;
import ee.ut.joshi.connectsix.logic.GameController;
import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.Player;
import ee.ut.joshi.connectsix.model.linear.LinearBoard;
import ee.ut.joshi.connectsix.model.player.RandomPlayer;
import ee.ut.joshi.connectsix.model.player.ScoreBasedPlayer;

public class RandomGamesGenerator {

	public static void playScoredVsRandom( DataEntryDao entryDao, LinearBoard board, int nrOfGames ) {

		for( int i = 0; i < nrOfGames; i++ ) {

			Board<? extends Object> cloneBoard = BoardCloneFactory.cloneBoard( board );

			Player plrOne = new ScoreBasedPlayer( Board.PLRONE );
			Player plrTwo = new RandomPlayer( Board.PLRTWO );

			GameController game = new GameController( cloneBoard, plrOne, plrTwo );
			game.setActivePlayer( plrOne );

			Player winner = game.startGame();

			DataEntry entry = new LinearDataEntry( (byte[]) game.getBoard().getFields(), winner.getValue() );

			entryDao.saveDataEntry( entry );
		}
	}

	public static void playRandomVsScored( DataEntryDao entryDao, LinearBoard board, int nrOfGames ) {

		for( int i = 0; i < nrOfGames; i++ ) {

			Board<? extends Object> cloneBoard = BoardCloneFactory.cloneBoard( board );

			Player plrOne = new RandomPlayer( Board.PLRONE );
			Player plrTwo = new ScoreBasedPlayer( Board.PLRTWO );

			GameController game = new GameController( cloneBoard, plrOne, plrTwo );
			game.setActivePlayer( plrOne );

			Player winner = game.startGame();

			DataEntry entry = new LinearDataEntry( (byte[]) game.getBoard().getFields(), winner.getValue() );

			entryDao.saveDataEntry( entry );
		}
	}

	public static void playRandomVsRandom( DataEntryDao entryDao, LinearBoard board, int nrOfGames ) {

		for( int i = 0; i < nrOfGames; i++ ) {

			Board<? extends Object> cloneBoard = BoardCloneFactory.cloneBoard( board );

			Player plrOne = new RandomPlayer( Board.PLRONE );
			Player plrTwo = new RandomPlayer( Board.PLRTWO );

			GameController game = new GameController( cloneBoard, plrOne, plrTwo );
			game.setActivePlayer( plrOne );

			Player winner = game.startGame();

			DataEntry entry = new LinearDataEntry( (byte[]) game.getBoard().getFields(), winner.getValue() );

			entryDao.saveDataEntry( entry );
		}
	}
}
