package ee.ut.joshi.connectsix.main;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import ee.ut.joshi.connectsix.logic.GameController;
import ee.ut.joshi.connectsix.model.Player;
import ee.ut.joshi.connectsix.model.linear.LinearBoard;
import ee.ut.joshi.connectsix.model.player.RandomPlayer;

public class ConnectObot {
	
	private static final Logger log = Logger.getLogger( ConnectObot.class );

	public static void main( String[] args ) {
		
		PropertyConfigurator.configure( "etc/log4j-aitest.properties" );
		
		log.info( "ConnectObot initiated." );

		LinearBoard board = new LinearBoard();

		Player plOne = new RandomPlayer( 1 );
		Player plTwo = new RandomPlayer( 2 );

		GameController c = new GameController( board, plOne, plTwo );

		c.setActivePlayer( plOne );

		c.startGame();
	}
}
