package ee.ut.joshi.connectsix.main;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.dataattr.DataSet;
import ee.ut.joshi.connectsix.ai.randomforest.db.DataEntryDao;
import ee.ut.joshi.connectsix.ai.randomforest.db.InitDatabase;
import ee.ut.joshi.connectsix.ai.randomforest.football.FootballDataEntry;
import ee.ut.joshi.connectsix.ai.randomforest.football.FootballDataEntryDao;
import ee.ut.joshi.connectsix.ai.randomforest.football.FootballDataSetDao;
import ee.ut.joshi.connectsix.ai.randomforest.football.InitDatabaseFootball;
import ee.ut.joshi.connectsix.ai.randomforest.train.TrainForest;
import ee.ut.joshi.connectsix.logic.FootballTrainer;

public class ConnectObotDB {

	private static final Logger log = Logger.getLogger( ConnectObotDB.class );

	public static void main( String[] args ) {

		PropertyConfigurator.configure( "etc/log4j.properties" );

		InitDatabase db = new InitDatabaseFootball();

		DataEntryDao entryDao = new FootballDataEntryDao( db.getConnection() );

		entryDao.saveDataEntry( new FootballDataEntry( "D1", "Sunny", "Hot", "High", "Weak", "No" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D2", "Sunny", "Hot", "High", "Strong", "No" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D3", "Overcast", "Hot", "High", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D4", "Rain", "Mild", "High", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D5", "Rain", "Cool", "Normal", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D6", "Rain", "Cool", "Normal", "Strong", "No" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D7", "Overcast", "Cool", "Normal", "Strong", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D8", "Sunny", "Mild", "High", "Weak", "No" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D9", "Sunny", "Cool", "Normal", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D10", "Rain", "Mild", "Normal", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D11", "Sunny", "Mild", "Normal", "Strong", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D12", "Overcast", "Mild", "High", "Strong", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D13", "Overcast", "Hot", "Normal", "Weak", "Yes" ) );
		entryDao.saveDataEntry( new FootballDataEntry( "D14", "Rain", "Mild", "High", "Strong", "No" ) );
		FootballDataSetDao setDao = new FootballDataSetDao( db.getConnection() );

		DataSet dataSet = setDao.getDataSet();

		for( DataEntry dataEntry : dataSet.getData() ) {
			log.debug( dataEntry );
		}

		// TrainTree trainTree = new TrainTree();
		// DecisionTree tree = trainTree.trainID3tree( dataSet,
		// dataSet.getAttrIndexes() );
		// log.debug( tree );

		TrainForest trainForest = new TrainForest( setDao );

		// RandomForest forest = trainForest.trainForest();
		//
		// log.debug( forest );
		//
		// forest.findCategory( dataSet.getData().get( 0 ) );
		//

		FootballTrainer t = new FootballTrainer( dataSet, trainForest );

		t.startTraining();
	}
}
