package ee.ut.joshi.connectsix.main;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import ee.ut.joshi.connectsix.model.DualMove;
import ee.ut.joshi.connectsix.model.Move;

public class ConnectObotProps extends Properties {

	private static final long serialVersionUID = 6025566166334601018L;

	private static Properties props;

	public ConnectObotProps() {

	}

	@Override
	public synchronized void load( InputStream inStream ) throws IOException {

		props = this;

		super.load( inStream );
	}

	public static int boardWidth() {

		return Integer.valueOf( props.getProperty( "board_width" ) );
	}

	public static int boardInaRow() {

		return Integer.valueOf( props.getProperty( "board_inarow" ) );
	}
	
	public static int smartMoveDistance() {

		return Integer.valueOf( props.getProperty( "board_smartmovedist" ) );
	}

	public static Class<? extends Move> boardMoveType() {
		
		String value = props.getProperty( "board_movetype" );
		
		if( value.equals( "singlemove" ) )
			return Move.class;

		if( value.equals( "dualmove" ) )
			return DualMove.class;
		
		return Move.class;
	}

	public static int[] trainerScoreValues() {

		int[] values = new int[6];

		values[ 0 ] = Integer.valueOf( props.getProperty( "trainer_winvalue" ) );
		values[ 1 ] = Integer.valueOf( props.getProperty( "trainer_drawvalue" ) );
		values[ 2 ] = Integer.valueOf( props.getProperty( "trainer_lossvalue" ) );
		values[ 3 ] = Integer.valueOf( props.getProperty( "trainer_winvalue2" ) );
		values[ 4 ] = Integer.valueOf( props.getProperty( "trainer_drawvalue2" ) );
		values[ 5 ] = Integer.valueOf( props.getProperty( "trainer_lossvalue2" ) );

		return values;
	}

	public static int nrOfThreads() {

		return Integer.valueOf( props.getProperty( "trainer_nrofthreads" ) );
	}

	public static long timeLimit() {

		int mins = Integer.valueOf( props.getProperty( "trainer_timelimit_min" ) );
		int hour = Integer.valueOf( props.getProperty( "trainer_timelimit_hours" ) );

		// milliseconds * seconds * minutes * hours
		long minutes = 1000 * 60 * mins;
		long hours = 1000 * 60 * 60 * hour;

		return minutes + hours;
	}

	public static int nrOfIterations() {

		return Integer.valueOf( props.getProperty( "trainer_nrofiterations" ) );
	}
	
	public static int gamesPerIndiv() {

		return Integer.valueOf( props.getProperty( "trainer_gamesperindiv" ) );
	}

	public static int minimaxDepth() {

		return Integer.valueOf( props.getProperty( "minimax_maxdepth" ) );
	}

	public static double winPredictionWeight() {

		return Double.valueOf( props.getProperty( "minimax_winprediction_weight" ) );
	}

	public static double drawPredictionWeight() {

		return Double.valueOf( props.getProperty( "minimax_drawprediction_weight" ) );
	}

	public static double lossPredictionWeight() {

		return Double.valueOf( props.getProperty( "minimax_lossprediction_weight" ) );
	}
	
	public static boolean usePreviousState() {
		
		return Boolean.valueOf( props.getProperty( "genetic_usepreviousstate" ) );
	}

	public static int geneticPopulation() {

		return Integer.valueOf( props.getProperty( "genetic_population" ) );
	}

	public static double geneticMutation() {

		return Double.valueOf( props.getProperty( "genetic_mutation" ) );
	}

	public static boolean forestTrainCached() {

		return Boolean.valueOf( props.getProperty( "forest_traincached" ) );
	}

	public static int forestNrOfAttrs() {

		return Integer.valueOf( props.getProperty( "forest_numberofattrs" ) );
	}

	public static int forestNrOfTrees() {

		return Integer.valueOf( props.getProperty( "forest_numberoftrees" ) );
	}
	
	public static int forestAttrRadius() {

		return Integer.valueOf( props.getProperty( "forest_attributeradius" ) );
	}
}
