package ee.ut.joshi.connectsix.main;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import ee.ut.joshi.connectsix.ai.randomforest.db.ImportDatabase;

public class DatabaseImport {

	private static final Logger log = Logger.getLogger( DatabaseImport.class );

	public static void main( String[] args ) throws FileNotFoundException, IOException {

		PropertyConfigurator.configure( "etc/log4j-aitest.properties" );
		ConnectObotProps props = new ConnectObotProps();
		props.load( new FileInputStream( "etc/gomoku.properties" ) );

		if( args.length != 2 ) {

			log.fatal( "Incorrect number of parameters: " + args.length );
			log.info( "Usage: java -jar dbimport.jar exportFrom importTo" );
			System.exit( 0 );
		}

		ImportDatabase importDB = new ImportDatabase( args[ 0 ], args[ 1 ] );

		importDB.startImport();

	}
}
