package ee.ut.joshi.connectsix.main;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.log4j.PropertyConfigurator;

import ee.ut.joshi.connectsix.logic.GameController;
import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.ConnectFourBoard;
import ee.ut.joshi.connectsix.model.player.HumanPlayer;

public class HumanTest {

	public static void main( String[] args ) throws FileNotFoundException, IOException {

		PropertyConfigurator.configure( "etc/log4j-gui.properties" );
		ConnectObotProps props = new ConnectObotProps();
		props.load( new FileInputStream( "etc/connect-four.properties" ) );

		HumanPlayer plOne = new HumanPlayer( Board.PLRONE, "TesterDude" );
		HumanPlayer plTwo = new HumanPlayer( Board.PLRTWO, "TesterGirl" );

		GameController game = new GameController( new ConnectFourBoard(), plOne, plTwo );

		game.setActivePlayer( plOne );

		game.startGame();

		System.out.println( game.getBoard() );

		System.out.println( "Game over, winner=" + game.getWinner() );
	}
}
