package ee.ut.joshi.connectsix.model;

import java.util.Random;


abstract public class Player implements Comparable<Player>{

	private byte value;
	private String name;

	public Player( byte value ) {

		Random r = new Random();

		this.value = value;
		this.name = "" + ( r.nextInt( 899 ) + 100 );
	}

	public Player( byte value, String name ) {

		this.value = value;
		this.name = name;
	}

	public Player( int value ) {

		this( (byte) value );
	}

	abstract public Move getNextMove( Board<? extends Object> board );

	public void setValue( byte value ) {
		this.value = value;
	}

	public byte getValue() {
		return value;
	}

	public String getName() {
		return name;
	}

	public void setName( String name ) {
		this.name = name;
	}
	
	
	@Override
	public int compareTo( Player plr ) {

		if( getName().compareTo( plr.getName() ) == 0 )
			if( getValue() == plr.getValue() )
				return 0;
		
		return -1;
	}
	
	@Override
	public boolean equals( Object obj ) {
	
		if( obj instanceof Player ) {
		
			Player plr = (Player)obj;
			
			if( getName().compareTo( plr.getName() ) == 0 )
				if( getValue() == plr.getValue() )
					return true;
		
		}
			
		return false;
	}
	
	@Override
	public int hashCode() {
	
		String id = "hash" + getClass() + getValue() + getName();
		
		return id.hashCode();
	}

	@Override
	public String toString() {

		return value + ":" + name;
	}
}
