package ee.ut.joshi.connectsix.model;

import java.util.ArrayList;

import ee.ut.joshi.connectsix.model.linear.LinearMove;

public class SmartC6Board extends SmartGomokuBoard {

	public SmartC6Board() {

		this( true );
	}

	public SmartC6Board( boolean init ) {

		if( init ) {

			ArrayList<Move> smartMoves = new ArrayList<>( Board.NROFFIELDS );

			setSmartMoves( smartMoves );

			byte[] fields = new byte[ Board.NROFFIELDS ];

			for( int i = 0; i < fields.length; i++ ) {

				fields[ i ] = 0;
			}

			int middle = Board.NROFFIELDS / 2;
			// According to rules, second player starts in the middle with single move
			fields[ middle ] = Board.PLRTWO;

			setFields( fields );

			super.addSmartMoves( new LinearMove( middle - 1 ) );
			super.addSmartMoves( new LinearMove( middle + 1 ) );
			super.addSmartMoves( new LinearMove( middle - Board.WIDTH ) );
			super.addSmartMoves( new LinearMove( middle + Board.WIDTH ) );
		}
	}
}
