package ee.ut.joshi.connectsix.model.linear;

import ee.ut.joshi.connectsix.model.Move;

/**
 * Game play move with one position. Position value is considered to be with
 * linear type of the game board data, i.e. a single array of fields
 */
public class LinearMove implements Move {

	private final LinearPosition pos;

	public LinearMove( LinearPosition pos ) {

		this.pos = pos;
	}

	public LinearMove( int position ) {

		this( new LinearPosition( position ) );
	}

	@Override
	public boolean equals( Object o ) {

		if( o instanceof LinearMove ) {

			LinearMove move = (LinearMove) o;

			return pos.getPosition() == move.getPosition().getPosition();
		}

		return false;
	}

	@Override
	public LinearPosition getPosition() {

		return pos;
	}

	@Override
	public String toString() {

		return "{" + pos + "}";
	}
}
