package ee.ut.joshi.connectsix.model.player;

import java.awt.event.ActionEvent;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.RandomForest;
import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.Move;
import ee.ut.joshi.connectsix.model.linear.LinearPosition;
import ee.ut.joshi.connectsix.ui.game.GuiGameController;

public class GuiNegamaxPlayer extends NegaMaxPlayer implements Runnable {

	private static Logger log = Logger.getLogger( GuiNegamaxPlayer.class );

	private Board<? extends Object> board;
	GuiGameController game;

	public GuiNegamaxPlayer( int value, RandomForest forest, boolean verbose ) {

		super( value, forest, verbose );
	}

	@Override
	public void run() {
		log.debug( "Requesting next move for player " + this );

		Move move = super.getNextMove( board );

		LinearPosition pos = (LinearPosition) move.getPosition();

		ActionEvent event = new ActionEvent( this, 101010, "" + pos.getPosition() );

		game.actionPerformed( event );
	}

	@Override
	public Move getNextMove( Board<? extends Object> board ) {

		this.board = board;

		Thread thread = new Thread( this );
		thread.start();

		return null;
	}

	@Override
	public String toString() {

		return super.toString();
	}

	public GuiGameController getGame() {
		return game;
	}

	public void setGame( GuiGameController game ) {
		this.game = game;
	}
}
