package ee.ut.joshi.connectsix.model.player;

import java.util.List;
import java.util.Random;

import ee.ut.joshi.connectsix.model.Board;
import ee.ut.joshi.connectsix.model.Move;
import ee.ut.joshi.connectsix.model.Player;

public class RandomPlayer extends Player {

	private Random r = new Random();

	public RandomPlayer( int value ) {

		super( value );
	}

	public RandomPlayer( int value, long seed ) {

		super( value );

		r = new Random( seed );
	}

	@Override
	public Move getNextMove( Board<? extends Object> board ) {

		List<Move> moves = board.getNextMoves();

		return moves.get( r.nextInt( moves.size() ) );
	}

	public Random getRandom() {
		return r;
	}

	public void setRandom( Random r ) {
		this.r = r;
	}

	@Override
	public String toString() {

		return "Random :" + super.toString();
	}
}
