package ee.ut.joshi.connectsix.ui;

import java.awt.Color;
import java.awt.GridLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.apache.log4j.Logger;

import ee.ut.joshi.connectsix.ai.randomforest.ForestTree;
import ee.ut.joshi.connectsix.ai.randomforest.RandomForest;
import ee.ut.joshi.connectsix.ai.randomforest.RandomWoods;
import ee.ut.joshi.connectsix.main.ConnectObotProps;

public class ForestVisualizer extends JFrame {

	private static final Logger log = Logger.getLogger( ForestVisualizer.class );

	/**  */
	private static final long serialVersionUID = 1L;

	private static final int attrRadius = ConnectObotProps.forestAttrRadius();

	public ForestVisualizer( RandomForest forest ) {

		setTitle( "Simple example" );
		setSize( 400, 400 );
		setDefaultCloseOperation( EXIT_ON_CLOSE );

		setLayout( new GridLayout( 0, 8, 3, 3 ) );

		// setLayout( new GridLayout( 0, (int) Math.sqrt( forest.getWoods().get( 0 ).getTrees().size() ), 1, 1 ) );

		for( RandomWoods woods : forest.getWoods() ) {

			// for( ForestTree tree : woods.getTrees() ) {
			//
			// add( new TreeVisualizer( tree ) );
			// }
			// TODO: How to visualize this correctly?
			add( new TreeVisualizer( woods.getTrees().get( 0 ) ) );
		}
	}

	private class TreeVisualizer extends JPanel {

		/**  */
		private static final long serialVersionUID = 1L;

		public TreeVisualizer( ForestTree tree ) {

			// setLayout( new GridLayout( Board.WIDTH, Board.WIDTH ) );
			setLayout( new GridLayout( attrRadius, attrRadius ) );

			log.debug( "Decision attrs=" + tree.getDecisionAttr() );

			// for( int i = 0; i < Board.NROFFIELDS; i++ ) {
			for( int i = 0; i < attrRadius * attrRadius; i++ ) {

				JButton button = new JButton( "" );

				if( tree.getDecisionAttr().indexOf( i ) != -1 )
					button.setBackground( Color.RED );

				add( button );
			}
		}
	}
}
