package ee.ut.joshi.connectsix.ui;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.PropertyConfigurator;
import org.xml.sax.SAXException;

import ee.ut.joshi.connectsix.ai.randomforest.RandomForest;
import ee.ut.joshi.connectsix.logic.factory.RandomForestParserXML;
import ee.ut.joshi.connectsix.main.ConnectObotProps;

public class GomokuGui {

	private final static String filename = "test/visualise.xml";

	public static void main( String[] args ) throws FileNotFoundException, IOException, ParserConfigurationException, SAXException {

		PropertyConfigurator.configure( "etc/log4j-gui.properties" );
		ConnectObotProps props = new ConnectObotProps();
		props.load( new FileInputStream( "etc/gomoku.properties" ) );

		InputStream io;

		try {
			io = new FileInputStream( filename );
		} catch( FileNotFoundException e ) {

			System.out.println( "File not found: " + filename );
			return;
		}

		System.out.println( "Forest file=" + filename );

		RandomForest forest;
		RandomForestParserXML parser = new RandomForestParserXML( io );

		forest = parser.parseForest();

		ForestVisualizer gui = new ForestVisualizer( forest );

		gui.setVisible( true );
	}
}
