package ee.ut.joshi.connectsix.ui.game;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.apache.log4j.Logger;

public class GameTypePanel extends JPanel implements ActionListener {

	private static final Logger log = Logger.getLogger( GameTypePanel.class );

	private static final long serialVersionUID = 1L;

	private byte gameType = GuiProperties.GOMOKU10;

	public GameTypePanel() {

		super( new GridLayout( 2, 2, 10, 10 ) );

		// One button for each game type
		JRadioButton gameButton;
		ButtonGroup group = new ButtonGroup();

		gameButton = new JRadioButton( GuiProperties.CONNECTFOUR_NAME );
		gameButton.setActionCommand( "" + GuiProperties.CONNECTFOUR );
		gameButton.addActionListener( this );
		group.add( gameButton );
		add( gameButton );

		gameButton = new JRadioButton( GuiProperties.GOMOKU7_NAME );
		gameButton.setActionCommand( "" + GuiProperties.GOMOKU7 );
		gameButton.addActionListener( this );
		group.add( gameButton );
		add( gameButton );

		gameButton = new JRadioButton( GuiProperties.GOMOKU10_NAME );
		gameButton.setActionCommand( "" + GuiProperties.GOMOKU10 );
		gameButton.addActionListener( this );
		gameButton.setSelected( true ); // Default button
		group.add( gameButton );
		add( gameButton );

	}

	@Override
	public void actionPerformed( ActionEvent e ) {

		log.info( "setting game  type=" + e.getActionCommand() );

		if( e.getActionCommand().equals( "" + GuiProperties.CONNECTFOUR ) )
			gameType = GuiProperties.CONNECTFOUR;

		if( e.getActionCommand().equals( "" + GuiProperties.GOMOKU7 ) )
			gameType = GuiProperties.GOMOKU7;

		if( e.getActionCommand().equals( "" + GuiProperties.GOMOKU10 ) )
			gameType = GuiProperties.GOMOKU10;
	}

	public byte getGameType() {
		return gameType;
	}

	public void setGameType( byte gameType ) {
		this.gameType = gameType;
	}
}
